diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/network/helper/application-helper.h ns-3.42/src/network/helper/application-helper.h
--- ns-3.41/src/network/helper/application-helper.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.42/src/network/helper/application-helper.h	2024-05-29 15:29:47.148073700 -0700
@@ -0,0 +1,145 @@
+/*
+ * Copyright (c) 2024 DERONNE SOFTWARE ENGINEERING
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#ifndef APPLICATIONS_HELPER_H
+#define APPLICATIONS_HELPER_H
+
+#include "application-container.h"
+#include "node-container.h"
+
+#include <ns3/address.h>
+#include <ns3/attribute.h>
+#include <ns3/object-factory.h>
+
+#include <string>
+
+namespace ns3
+{
+
+/**
+ * \brief A helper to make it easier to instantiate an application on a set of nodes.
+ */
+class ApplicationHelper
+{
+  public:
+    /**
+     * Create an application of a given type ID
+     *
+     * @param typeId the type ID.
+     */
+    explicit ApplicationHelper(TypeId typeId);
+
+    /**
+     * Create an application of a given type ID
+     *
+     * @param typeId the type ID expressed as a string.
+     */
+    explicit ApplicationHelper(const std::string& typeId);
+
+    /**
+     * Allow the helper to be repurposed for another application type
+     *
+     * @param typeId the type ID.
+     */
+    void SetTypeId(TypeId typeId);
+
+    /**
+     * Allow the helper to be repurposed for another application type
+     *
+     * @param typeId the type ID expressed as a string.
+     */
+    void SetTypeId(const std::string& typeId);
+
+    /**
+     * Helper function used to set the underlying application attributes.
+     *
+     * @param name the name of the application attribute to set
+     * @param value the value of the application attribute to set
+     */
+    void SetAttribute(const std::string& name, const AttributeValue& value);
+
+    /**
+     * Install an application on each node of the input container
+     * configured with all the attributes set with SetAttribute.
+     *
+     * @param c NodeContainer of the set of nodes on which an application
+     * will be installed.
+     * @return Container of Ptr to the applications installed.
+     */
+    ApplicationContainer Install(NodeContainer c);
+
+    /**
+     * Install an application on the node configured with all the
+     * attributes set with SetAttribute.
+     *
+     * @param node The node on which an application will be installed.
+     * @return Container of Ptr to the applications installed.
+     */
+    ApplicationContainer Install(Ptr<Node> node);
+
+    /**
+     * Install an application on the node configured with all the
+     * attributes set with SetAttribute.
+     *
+     * @param nodeName The node on which an application will be installed.
+     * @return Container of Ptr to the applications installed.
+     */
+    ApplicationContainer Install(const std::string& nodeName);
+
+    /**
+     * Assigns a unique (monotonically increasing) stream number to all applications that match the
+     * configured type of this application helper instance. Return the number of streams (possibly
+     * zero) that have been assigned. The Install() method should have previously been called by the
+     * user.
+     *
+     * @param stream first stream index to use
+     * @param c NodeContainer of the set of nodes for which the application should be modified to
+     * use a fixed stream
+     * @return the number of stream indices assigned by this helper
+     */
+    int64_t AssignStreams(NodeContainer c, int64_t stream);
+
+    /**
+     * Assign a fixed random variable stream number to the random variables used by all the
+     * applications. Return the number of streams (possibly zero) that have been assigned. The
+     * Install() method should have previously been called by the user.
+     *
+     * @param stream first stream index to use
+     * @param c NodeContainer of the set of nodes for which their applications should be modified to
+     * use a fixed stream
+     * @return the number of stream indices assigned by this helper
+     */
+    static int64_t AssignStreamsToAllApps(NodeContainer c, int64_t stream);
+
+  protected:
+    /**
+     * Install an application on the node configured with all the
+     * attributes set with SetAttribute.
+     *
+     * @param node The node on which an application will be installed.
+     * @return Ptr to the application installed.
+     */
+    virtual Ptr<Application> DoInstall(Ptr<Node> node);
+
+    ObjectFactory m_factory; //!< Object factory.
+};
+
+} // namespace ns3
+
+#endif /* APPLICATIONS_HELPER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/network/model/address.cc ns-3.42/src/network/model/address.cc
--- ns-3.41/src/network/model/address.cc	2024-02-09 14:44:08.401793700 -0800
+++ ns-3.42/src/network/model/address.cc	2024-05-29 15:29:47.148073700 -0700
@@ -245,6 +245,10 @@
 std::ostream&
 operator<<(std::ostream& os, const Address& address)
 {
+    if (address.m_len == 0)
+    {
+        return os;
+    }
     os.setf(std::ios::hex, std::ios::basefield);
     os.fill('0');
     os << std::setw(2) << (uint32_t)address.m_type << "-" << std::setw(2) << (uint32_t)address.m_len
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/network/model/application.cc ns-3.42/src/network/model/application.cc
--- ns-3.41/src/network/model/application.cc	2024-02-09 14:44:08.401793700 -0800
+++ ns-3.42/src/network/model/application.cc	2024-05-29 15:29:47.148073700 -0700
@@ -132,4 +132,11 @@
     NS_LOG_FUNCTION(this);
 }
 
+int64_t
+Application::AssignStreams(int64_t stream)
+{
+    NS_LOG_FUNCTION(this << stream);
+    return 0;
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/network/model/application.h ns-3.42/src/network/model/application.h
--- ns-3.41/src/network/model/application.h	2024-02-09 14:44:08.401793700 -0800
+++ ns-3.42/src/network/model/application.h	2024-05-29 15:29:47.148073700 -0700
@@ -106,6 +106,15 @@
     void SetNode(Ptr<Node> node);
 
     /**
+     * \brief Assign a fixed random variable stream number to the random variables
+     * used by this Application object.
+     *
+     * \param stream first stream index to use
+     * \return the number of stream indices assigned by this Application object
+     */
+    virtual int64_t AssignStreams(int64_t stream);
+
+    /**
      * \brief Common callback signature for packet delay and address.
      *
      * \param delay The packet delay.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/network/model/node.cc ns-3.42/src/network/model/node.cc
--- ns-3.41/src/network/model/node.cc	2024-02-09 14:44:08.401793700 -0800
+++ ns-3.42/src/network/model/node.cc	2024-05-29 15:29:47.148073700 -0700
@@ -116,21 +116,18 @@
 uint32_t
 Node::GetId() const
 {
-    NS_LOG_FUNCTION(this);
     return m_id;
 }
 
 Time
 Node::GetLocalTime() const
 {
-    NS_LOG_FUNCTION(this);
     return Simulator::Now();
 }
 
 uint32_t
 Node::GetSystemId() const
 {
-    NS_LOG_FUNCTION(this);
     return m_sid;
 }
 
@@ -151,7 +148,6 @@
 Ptr<NetDevice>
 Node::GetDevice(uint32_t index) const
 {
-    NS_LOG_FUNCTION(this << index);
     NS_ASSERT_MSG(index < m_devices.size(),
                   "Device index " << index << " is out of range (only have " << m_devices.size()
                                   << " devices).");
@@ -161,7 +157,6 @@
 uint32_t
 Node::GetNDevices() const
 {
-    NS_LOG_FUNCTION(this);
     return m_devices.size();
 }
 
@@ -179,7 +174,6 @@
 Ptr<Application>
 Node::GetApplication(uint32_t index) const
 {
-    NS_LOG_FUNCTION(this << index);
     NS_ASSERT_MSG(index < m_applications.size(),
                   "Application index " << index << " is out of range (only have "
                                        << m_applications.size() << " applications).");
@@ -189,7 +183,6 @@
 uint32_t
 Node::GetNApplications() const
 {
-    NS_LOG_FUNCTION(this);
     return m_applications.size();
 }
 
@@ -284,7 +277,6 @@
 bool
 Node::ChecksumEnabled()
 {
-    NS_LOG_FUNCTION_NOARGS();
     BooleanValue val;
     g_checksumEnabled.GetValue(val);
     return val.Get();
@@ -333,9 +325,6 @@
                   "Received packet with erroneous context ; "
                       << "make sure the channels in use are correctly updating events context "
                       << "when transferring events from one node to another.");
-    NS_LOG_DEBUG("Node " << GetId() << " ReceiveFromDevice:  dev " << device->GetIfIndex()
-                         << " (type=" << device->GetInstanceTypeId().GetName() << ") Packet UID "
-                         << packet->GetUid());
     bool found = false;
 
     for (auto i = m_handlers.begin(); i != m_handlers.end(); i++)
@@ -352,6 +341,9 @@
             }
         }
     }
+    NS_LOG_DEBUG("Node " << GetId() << " ReceiveFromDevice:  dev " << device->GetIfIndex()
+                         << " (type=" << device->GetInstanceTypeId().GetName() << ") Packet UID "
+                         << packet->GetUid() << " handler found: " << found);
     return found;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/network/model/socket.h ns-3.42/src/network/model/socket.h
--- ns-3.41/src/network/model/socket.h	2024-02-09 14:44:08.421793700 -0800
+++ ns-3.42/src/network/model/socket.h	2024-05-29 15:29:47.148073700 -0700
@@ -779,9 +779,11 @@
      * \brief Manually set IP Type of Service field
      *
      * This method corresponds to using setsockopt () IP_TOS of
-     * real network or BSD sockets. This option is for IPv4 only.
+     * real network or BSD sockets.
      * Setting the IP TOS also changes the socket priority as
      * stated in the man page.
+     * This option affects only IPv4 sockets, it has no effect
+     * on IPv6 sockets.
      *
      * \param ipTos The desired TOS value for IP headers
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/network/test/bit-serializer-test.cc ns-3.42/src/network/test/bit-serializer-test.cc
--- ns-3.41/src/network/test/bit-serializer-test.cc	2024-02-09 14:44:08.421793700 -0800
+++ ns-3.42/src/network/test/bit-serializer-test.cc	2024-05-29 15:29:47.148073700 -0700
@@ -153,10 +153,10 @@
 };
 
 BitSerializerTestSuite::BitSerializerTestSuite()
-    : TestSuite("bit-serializer", UNIT)
+    : TestSuite("bit-serializer", Type::UNIT)
 {
-    AddTestCase(new BitSerializerTest, TestCase::QUICK);
-    AddTestCase(new BitDeserializerTest, TestCase::QUICK);
+    AddTestCase(new BitSerializerTest, TestCase::Duration::QUICK);
+    AddTestCase(new BitDeserializerTest, TestCase::Duration::QUICK);
 }
 
 static BitSerializerTestSuite g_bitSerializerTest; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/network/test/buffer-test.cc ns-3.42/src/network/test/buffer-test.cc
--- ns-3.41/src/network/test/buffer-test.cc	2024-02-09 14:44:08.421793700 -0800
+++ ns-3.42/src/network/test/buffer-test.cc	2024-05-29 15:29:47.148073700 -0700
@@ -408,9 +408,9 @@
 };
 
 BufferTestSuite::BufferTestSuite()
-    : TestSuite("buffer", UNIT)
+    : TestSuite("buffer", Type::UNIT)
 {
-    AddTestCase(new BufferTest, TestCase::QUICK);
+    AddTestCase(new BufferTest, TestCase::Duration::QUICK);
 }
 
 static BufferTestSuite g_bufferTestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/network/test/drop-tail-queue-test-suite.cc ns-3.42/src/network/test/drop-tail-queue-test-suite.cc
--- ns-3.41/src/network/test/drop-tail-queue-test-suite.cc	2024-02-09 14:44:08.421793700 -0800
+++ ns-3.42/src/network/test/drop-tail-queue-test-suite.cc	2024-05-29 15:29:47.148073700 -0700
@@ -97,9 +97,9 @@
 {
   public:
     DropTailQueueTestSuite()
-        : TestSuite("drop-tail-queue", UNIT)
+        : TestSuite("drop-tail-queue", Type::UNIT)
     {
-        AddTestCase(new DropTailQueueTestCase(), TestCase::QUICK);
+        AddTestCase(new DropTailQueueTestCase(), TestCase::Duration::QUICK);
     }
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/network/test/error-model-test-suite.cc ns-3.42/src/network/test/error-model-test-suite.cc
--- ns-3.41/src/network/test/error-model-test-suite.cc	2024-02-09 14:44:08.421793700 -0800
+++ ns-3.42/src/network/test/error-model-test-suite.cc	2024-05-29 15:29:47.148073700 -0700
@@ -305,10 +305,10 @@
 };
 
 ErrorModelTestSuite::ErrorModelTestSuite()
-    : TestSuite("error-model", UNIT)
+    : TestSuite("error-model", Type::UNIT)
 {
-    AddTestCase(new ErrorModelSimple, TestCase::QUICK);
-    AddTestCase(new BurstErrorModelSimple, TestCase::QUICK);
+    AddTestCase(new ErrorModelSimple, TestCase::Duration::QUICK);
+    AddTestCase(new BurstErrorModelSimple, TestCase::Duration::QUICK);
 }
 
 // Do not forget to allocate an instance of this TestSuite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/network/test/ipv6-address-test-suite.cc ns-3.42/src/network/test/ipv6-address-test-suite.cc
--- ns-3.41/src/network/test/ipv6-address-test-suite.cc	2024-02-09 14:44:08.421793700 -0800
+++ ns-3.42/src/network/test/ipv6-address-test-suite.cc	2024-05-29 15:29:47.148073700 -0700
@@ -109,9 +109,9 @@
 };
 
 Ipv6AddressTestSuite::Ipv6AddressTestSuite()
-    : TestSuite("ipv6-address", UNIT)
+    : TestSuite("ipv6-address", Type::UNIT)
 {
-    AddTestCase(new Ipv6AddressTestCase, TestCase::QUICK);
+    AddTestCase(new Ipv6AddressTestCase, TestCase::Duration::QUICK);
 }
 
 static Ipv6AddressTestSuite ipv6AddressTestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/network/test/lollipop-counter-test.cc ns-3.42/src/network/test/lollipop-counter-test.cc
--- ns-3.41/src/network/test/lollipop-counter-test.cc	2024-02-09 14:44:08.421793700 -0800
+++ ns-3.42/src/network/test/lollipop-counter-test.cc	2024-05-29 15:29:47.148073700 -0700
@@ -150,19 +150,19 @@
  *
  * \brief Lollipop Counter TestSuite
  */
-class LolipopCounterTestSuite : public TestSuite
+class LollipopCounterTestSuite : public TestSuite
 {
   public:
-    LolipopCounterTestSuite();
+    LollipopCounterTestSuite();
 
   private:
 };
 
-LolipopCounterTestSuite::LolipopCounterTestSuite()
-    : TestSuite("lollipop-counter", UNIT)
+LollipopCounterTestSuite::LollipopCounterTestSuite()
+    : TestSuite("lollipop-counter", Type::UNIT)
 {
-    AddTestCase(new LollipopCounterTest(), TestCase::QUICK);
+    AddTestCase(new LollipopCounterTest(), TestCase::Duration::QUICK);
 }
 
-static LolipopCounterTestSuite
+static LollipopCounterTestSuite
     g_lollipopCounterTestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/network/test/packetbb-test-suite.cc ns-3.42/src/network/test/packetbb-test-suite.cc
--- ns-3.41/src/network/test/packetbb-test-suite.cc	2024-02-09 14:44:08.421793700 -0800
+++ ns-3.42/src/network/test/packetbb-test-suite.cc	2024-05-29 15:29:47.148073700 -0700
@@ -123,7 +123,7 @@
 };
 
 PbbTestSuite::PbbTestSuite()
-    : TestSuite("packetbb-test-suite", UNIT)
+    : TestSuite("packetbb-test-suite", Type::UNIT)
 {
     /* Test 1
      *    ,------------------
@@ -136,7 +136,8 @@
     {
         Ptr<PbbPacket> packet = Create<PbbPacket>();
         uint8_t buffer[] = {0x00};
-        AddTestCase(new PbbTestCase("1", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("1", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 2
@@ -152,7 +153,8 @@
         Ptr<PbbPacket> packet = Create<PbbPacket>();
         packet->SetSequenceNumber(2);
         uint8_t buffer[] = {0x08, 0x00, 0x02};
-        AddTestCase(new PbbTestCase("2", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("2", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 3
@@ -171,7 +173,7 @@
     Ptr<PbbPacket> packet = Create<PbbPacket> ();
     packet->SetSequenceNumber (3);
     uint8_t buffer[] = { 0x0c, 0x00, 0x03, 0x00, 0x00};
-    AddTestCase (new PbbTestCase ("3", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+    AddTestCase (new PbbTestCase ("3", packet, buffer, sizeof(buffer)), TestCase::Duration::QUICK);
   }
 #endif
 
@@ -197,7 +199,8 @@
 
         packet->TlvPushBack(tlv);
         uint8_t buffer[] = {0x0c, 0x00, 0x04, 0x00, 0x02, 0x01, 0x00};
-        AddTestCase(new PbbTestCase("4", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("4", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 5
@@ -230,7 +233,8 @@
         packet->TlvPushBack(tlv2);
 
         uint8_t buffer[] = {0x0c, 0x00, 0x05, 0x00, 0x05, 0x01, 0x00, 0x02, 0x80, 0x64};
-        AddTestCase(new PbbTestCase("5", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("5", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 6
@@ -284,7 +288,8 @@
             0x03,
             0x04,
         };
-        AddTestCase(new PbbTestCase("6", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("6", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 7
@@ -443,7 +448,8 @@
             0x1b, 0x1c, 0x1d, 0x1e, 0x1f, 0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, 0x28,
             0x29, 0x2a, 0x2b, 0x2c,
         };
-        AddTestCase(new PbbTestCase("7", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("7", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 8
@@ -493,7 +499,8 @@
             0x00,
             0x00,
         };
-        AddTestCase(new PbbTestCase("8", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("8", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 9
@@ -546,7 +553,8 @@
             0x03, 0x00, 0x06, 0x00, 0x00, 0x02, 0x83, 0x00, /* [14] used to be 0x80 */
             0x0a, 0x0a, 0x00, 0x00, 0x01, 0x00, 0x00,
         };
-        AddTestCase(new PbbTestCase("9", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("9", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 10
@@ -601,7 +609,8 @@
             0x03, 0x00, 0x06, 0x00, 0x00, 0x02, 0xa3, 0x00, /* [14] used to be 0xa0 */
             0x0b, 0x0a, 0x00, 0x00, 0x01, 0x01, 0x00, 0x00,
         };
-        AddTestCase(new PbbTestCase("10", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("10", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 11
@@ -658,7 +667,8 @@
             0x00, 0x06, 0x00, 0x00, 0x02, 0xe3, 0x00, /* [14] used to be 0xe0 */
             0x0c, 0x0a, 0x00, 0x00, 0x01, 0xff, 0x01, 0x00, 0x00,
         };
-        AddTestCase(new PbbTestCase("11", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("11", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 12
@@ -717,7 +727,8 @@
             0x00, 0x00, 0x02, 0xf3, 0x00, /* [14] - 0xf0 */
             0x0e, 0x0a, 0x00, 0x00, 0x01, 0xff, 0x01, 0x30, 0x39, 0x00, 0x00,
         };
-        AddTestCase(new PbbTestCase("12", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("12", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 13
@@ -776,7 +787,8 @@
             0x00, 0x00, 0x02, 0xf3, 0x00, /* [14] - 0xf0 */
             0x0e, 0x0a, 0x00, 0x00, 0x01, 0xff, 0x01, 0x30, 0x39, 0x00, 0x00,
         };
-        AddTestCase(new PbbTestCase("13", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("13", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 14
@@ -844,7 +856,8 @@
             0x08, 0x00, 0x02, 0x01, 0x00, 0x02, 0xf3, 0x00, 0x0e, 0x0a, /* [16] - 0xf0 */
             0x00, 0x00, 0x01, 0xff, 0x01, 0x30, 0x39, 0x00, 0x00,
         };
-        AddTestCase(new PbbTestCase("14", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("14", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 15
@@ -922,7 +935,8 @@
             0x00, 0x00, 0x01, 0xff, 0x01, 0x30, 0x39, 0x00, 0x00, 0x01,
             0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
         };
-        AddTestCase(new PbbTestCase("15", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("15", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 16
@@ -1000,7 +1014,8 @@
             0x00, 0x00, 0x01, 0xff, 0x01, 0x30, 0x39, 0x00, 0x00, 0x01,
             0x00, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00,
         };
-        AddTestCase(new PbbTestCase("16", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("16", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 17
@@ -1078,7 +1093,8 @@
             0x00, 0x00, 0x01, 0xff, 0x01, 0x30, 0x39, 0x00, 0x00, 0x01,
             0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
         };
-        AddTestCase(new PbbTestCase("17", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("17", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 18
@@ -1156,7 +1172,8 @@
             0x00, 0x00, 0x01, 0xff, 0x01, 0x30, 0x39, 0x00, 0x00, 0x01,
             0x00, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00,
         };
-        AddTestCase(new PbbTestCase("18", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("18", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 19
@@ -1234,7 +1251,8 @@
             0x00, 0x00, 0x01, 0xff, 0x01, 0x30, 0x39, 0x00, 0x00, 0x01,
             0x00, 0x0a, 0x00, 0x00, 0x01, 0x00, 0x00,
         };
-        AddTestCase(new PbbTestCase("19", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("19", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 20
@@ -1314,7 +1332,8 @@
             0x00, 0x00, 0x01, 0xff, 0x01, 0x30, 0x39, 0x00, 0x00, 0x02,
             0x80, 0x03, 0x0a, 0x00, 0x00, 0x01, 0x02, 0x00, 0x00,
         };
-        AddTestCase(new PbbTestCase("20", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("20", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 21
@@ -1394,7 +1413,8 @@
             0x00, 0x00, 0x01, 0xff, 0x01, 0x30, 0x39, 0x00, 0x00, 0x02, 0xc0,
             0x01, 0x0a, 0x01, 0x02, 0x00, 0x00, 0x01, 0x01, 0x00, 0x00,
         };
-        AddTestCase(new PbbTestCase("21", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("21", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 22
@@ -1484,7 +1504,8 @@
             0x00, 0x00, 0x01, 0xff, 0x01, 0x30, 0x39, 0x00, 0x00, 0x02, 0xc0, 0x01, 0x0a, 0x01,
             0x02, 0x00, 0x00, 0x01, 0x01, 0x00, 0x00, 0x02, 0x20, 0x03, 0x0a, 0x0b, 0x00, 0x00,
         };
-        AddTestCase(new PbbTestCase("22", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("22", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 23
@@ -1586,7 +1607,8 @@
             0x00, 0x00, 0x00, 0x0b, 0x00, 0x00, 0x00, 0x0a, 0x00, 0x00, 0x05, 0x0a,
             0x00, 0x00, 0x06, 0x20, 0x20, 0x10, 0x18, 0x00, 0x00,
         };
-        AddTestCase(new PbbTestCase("23", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("23", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 24
@@ -1695,7 +1717,8 @@
             0x00, 0x00, 0x00, 0x0b, 0x00, 0x00, 0x00, 0x0a, 0x00, 0x00, 0x05, 0x0a,
             0x00, 0x00, 0x06, 0x20, 0x20, 0x10, 0x18, 0x00, 0x02, 0x01, 0x00,
         };
-        AddTestCase(new PbbTestCase("24", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("24", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 25
@@ -1806,7 +1829,8 @@
             0x00, 0x00, 0x00, 0x0b, 0x00, 0x00, 0x00, 0x0a, 0x00, 0x00, 0x05, 0x0a,
             0x00, 0x00, 0x06, 0x20, 0x20, 0x10, 0x18, 0x00, 0x03, 0x01, 0x40, 0x01,
         };
-        AddTestCase(new PbbTestCase("25", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("25", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 26
@@ -1919,7 +1943,8 @@
             0x00, 0x0b, 0x00, 0x00, 0x00, 0x0a, 0x00, 0x00, 0x05, 0x0a, 0x00, 0x00, 0x06,
             0x20, 0x20, 0x10, 0x18, 0x00, 0x04, 0x01, 0x20, 0x01, 0x03,
         };
-        AddTestCase(new PbbTestCase("26", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("26", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 27
@@ -2037,7 +2062,8 @@
             0x00, 0x00, 0x00, 0x0a, 0x00, 0x00, 0x05, 0x0a, 0x00, 0x00, 0x06, 0x20, 0x20, 0x10,
             0x18, 0x00, 0x08, 0x01, 0x34, 0x01, 0x03, 0x03, 0x01, 0x02, 0x03,
         };
-        AddTestCase(new PbbTestCase("27", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("27", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 28
@@ -2274,7 +2300,8 @@
             0x1e, 0x1f, 0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, 0x28, 0x29, 0x2a, 0x2b,
             0x2c,
         };
-        AddTestCase(new PbbTestCase("28", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("28", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 29
@@ -2309,7 +2336,8 @@
             0x00,
             0x00,
         };
-        AddTestCase(new PbbTestCase("29", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("29", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 30
@@ -2341,7 +2369,8 @@
             0x00, 0x01, 0x8f, 0x00, 0x16, 0xab, 0xcd, 0x00, 0x00, 0x00, 0x00, 0x00,
             0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
         };
-        AddTestCase(new PbbTestCase("30", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("30", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 31
@@ -2383,7 +2412,8 @@
             0x00, 0x01, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
             0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
         };
-        AddTestCase(new PbbTestCase("31", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("31", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 32
@@ -2427,7 +2457,8 @@
             0x80, 0x0f, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
             0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x02, 0x00, 0x00,
         };
-        AddTestCase(new PbbTestCase("32", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("32", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 33
@@ -2471,7 +2502,8 @@
             0xc0, 0x0d, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
             0x00, 0x00, 0x00, 0x02, 0x00, 0x02, 0x00, 0x11, 0x00, 0x00,
         };
-        AddTestCase(new PbbTestCase("33", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("33", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 34
@@ -2525,7 +2557,8 @@
             0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x02,
             0x00, 0x11, 0x00, 0x00, 0x02, 0xa0, 0x01, 0x00, 0x0e, 0x10, 0x11, 0x00, 0x00,
         };
-        AddTestCase(new PbbTestCase("34", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("34", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 35
@@ -2592,7 +2625,8 @@
             0x00, 0x00, 0x00, 0x05, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
             0x00, 0x00, 0x00, 0x00, 0x00, 0x06, 0x80, 0x80, 0x40, 0x30, 0x00, 0x00,
         };
-        AddTestCase(new PbbTestCase("35", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("35", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 36
@@ -2874,7 +2908,8 @@
             0x00, 0x00, 0x05, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
             0x00, 0x00, 0x00, 0x06, 0x80, 0x80, 0x40, 0x30, 0x00, 0x00,
         };
-        AddTestCase(new PbbTestCase("36", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("36", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 
     /* Test 37
@@ -3156,7 +3191,8 @@
             0x00, 0x00, 0x05, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
             0x00, 0x00, 0x00, 0x06, 0x80, 0x80, 0x40, 0x30, 0x00, 0x00,
         };
-        AddTestCase(new PbbTestCase("37", packet, buffer, sizeof(buffer)), TestCase::QUICK);
+        AddTestCase(new PbbTestCase("37", packet, buffer, sizeof(buffer)),
+                    TestCase::Duration::QUICK);
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/network/test/packet-metadata-test.cc ns-3.42/src/network/test/packet-metadata-test.cc
--- ns-3.41/src/network/test/packet-metadata-test.cc	2024-02-09 14:44:08.421793700 -0800
+++ ns-3.42/src/network/test/packet-metadata-test.cc	2024-05-29 15:29:47.148073700 -0700
@@ -894,9 +894,9 @@
 };
 
 PacketMetadataTestSuite::PacketMetadataTestSuite()
-    : TestSuite("packet-metadata", UNIT)
+    : TestSuite("packet-metadata", Type::UNIT)
 {
-    AddTestCase(new PacketMetadataTest, TestCase::QUICK);
+    AddTestCase(new PacketMetadataTest, TestCase::Duration::QUICK);
 }
 
 static PacketMetadataTestSuite g_packetMetadataTest; //!< Static variable for test initialization
